/*
  File autogenerated by gengetopt version 2.12.1
  generated with the following command:
  gengetopt --input=volinfo_cmd.ggo --file-name=volinfo_cmd 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "volinfo_cmd.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

struct in_list
{
  char * in_arg;
  struct in_list * next;
};

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->in_given = 0 ;
  args_info->range_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->in_arg = NULL;
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Usage: %s [OPTIONS]...\n", CMDLINE_PARSER_PACKAGE);
  printf("\n");
  printf("%s\n","  -h, --help         Print help and exit");
  printf("%s\n","  -V, --version      Print version and exit");
  printf("%s\n","  -i, --in=filename  Input file name\n                        Must be a Voleon vol file");
  printf("%s\n","  -r, --range        Show the range of data.  May take a long time.");
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  
  int i;
  for (i = 0; i < args_info->in_given; ++i)
    {
      free (args_info->in_arg [i]); /* free previous argument */
      args_info->in_arg [i] = 0;
    }
  if (args_info->in_arg)
    {
      if (args_info->in_arg [0])
        free (args_info->in_arg [0]); /* free default string */
      free (args_info->in_arg); /* free previous argument */
      args_info->in_arg = 0;
    }
  
  clear_given (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}
static char *
get_multiple_arg_token(const char *arg)
{
  char *tok, *ret;
  int len;
  tok = strchr (arg, ',');

  if (tok)
    len = (tok - arg + 1);
  else
    len = strlen (arg) + 1;

  ret = (char *) malloc (len);
  strncpy (ret, arg, len-1);
  ret[len-1] = '\0';

  return ret;
}

static char *
get_multiple_arg_token_next(const char *arg)
{
  char *tok;
  tok = strchr (arg, ',');

  if (! tok || strlen(tok) == 1)
    return 0;

  return tok+1;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;
  
  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);
  
  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */
  char *multi_token, *multi_next; /* for multiple options */
  int i;        /* Counter */
  struct in_list * in_list = NULL,* in_new = NULL;
  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "in",	1, NULL, 'i' },
        { "range",	0, NULL, 'r' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVi:r", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'i':	/* Input file name\n Must be a Voleon vol file.  */
          local_args_info.in_given++;
          multi_token = get_multiple_arg_token(optarg);
          multi_next = get_multiple_arg_token_next (optarg);
          
          while (1)
            {
              in_new = (struct in_list *) malloc (sizeof (struct in_list));
              in_new->next = in_list;
              in_list = in_new;
              in_new->in_arg = multi_token;
          
              if (multi_next)
                {
                  multi_token = get_multiple_arg_token(multi_next);
                  multi_next = get_multiple_arg_token_next (multi_next);
                  local_args_info.in_given++;
                }
              else
                break;
            }
          break;

        case 'r':	/* Show the range of data.  May take a long time..  */
          if (local_args_info.range_given)
            {
              fprintf (stderr, "%s: `--range' (`-r') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->range_given && ! override)
            continue;
          local_args_info.range_given = 1;
          args_info->range_given = 1;
          break;


        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */


  if (local_args_info.in_given && in_list)
    {
      struct in_list *tmp;
      args_info->in_arg = (char * *) realloc (args_info->in_arg, (args_info->in_given + local_args_info.in_given) * sizeof (char *));
      for (i = (local_args_info.in_given - 1); i >= 0; --i)
        {
          tmp = in_list;
          args_info->in_arg [i + args_info->in_given] = in_list->in_arg;
          in_list = in_list->next;
          free (tmp);
        }
    }
  

  args_info->in_given += local_args_info.in_given;
  
  if (check_required)
    {
      if (! args_info->in_given)
        {
          fprintf (stderr, "%s: '--in' ('-i') option required%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
          error = 1;
        }
    }

  if ( error )
    return (EXIT_FAILURE);

  return 0;

failure:
  cmdline_parser_free (&local_args_info);
  return (EXIT_FAILURE);
}
